<?php

namespace Teknisa\DF\Modules\Saida\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource;
use Teknisa\DF\Modules\Saida\Services\DevolucaoOperadorLogisticoService;
    
class DevolucaoOperadorLogisticoController extends \Teknisa\DF\Controllers\TeknisaCrud {
    
    protected $devolucaoOperadorLogisticoService;
    protected $dataSourceName = 'dfs72000_notafiscal_devol';
    protected $entityManager;
    protected $environment;
    
    public function __construct(DevolucaoOperadorLogisticoService $devolucaoOperadorLogisticoService) {
        $this->devolucaoOperadorLogisticoService = $devolucaoOperadorLogisticoService;
    }
    
    public function gerarDevolucao(DTO\Request\DataSet $request, DTO\Response $response) {
        $dataSet = $request->getDataSet();
        
        $notasFiscais    = $dataSet->getRows()[0];
        $dadosDevolucao  = $dataSet->getRows()[1];
        $dadosAdicionais = $dataSet->getRows()[2];
        
        $this->devolucaoOperadorLogisticoService->gerarDevolucao($notasFiscais, $dadosDevolucao, $dadosAdicionais);
        
        $erros = $this->devolucaoOperadorLogisticoService->getErros();
        $numNotasSucesso = $this->devolucaoOperadorLogisticoService->getQtNotasSucesso();
        $response->addDataset(new DataSource\DataSet('errosDevolucao', $erros));
        if($numNotasSucesso != 0) {
            $response->addMessage(new Response\Message($numNotasSucesso));
        }
        else {
            $response->addMessage(new Response\Message("Não foi possível realizar a devolução das notas fiscais selecionadas."));
        }
    
    }

}
