<?php
namespace Faturamento\Repositories;

class Propostalinp extends \Doctrine\ORM\EntityRepository
{
    public function linhaProdutoAceite($proposta, $versao){
        $sql = "SELECT
                   PL.NRPROPOSFAS,
                   PL.NRVERPROPFAS,
                   PL.CDLINPPROP,
                   PL.CDLINPPROPINFOR,
                   PL.NMLINPPROP,
                   PL.NRUSUALINPP,
                   PL.IDTIPLINPP,
                   PL.QTMINIMAFATPROP,
                   TRUNC(NVL(PL.VRLICENCUSOPROP,0),2) AS VRLICENCUSOPROP,
                   NVL(PL.VRMENSALIDAPROP,0)AS VRMENSALIDAPROP,
                   TRUNC(NVL(PL.VRDESLICUSOPROP,0),2)AS VRDESLICUSOPROP,
                   NVL(PL.VRDESMENSALPROP,0)AS VRDESMENSALPROP,
                   PL.IDMPROCLINPP,
                   PL.IDLPROCLINPP,
                   PL.DTCALUSLINPP,
                   PL.IDAMBLINPP,
                   PR.IDCLIENPROSP,
                   PR.NRMESREAJPROP,
                   PR.IDTIPOPROPFAS,
                   TO_CHAR(PL.DTCALUSLINPP, 'MM/YYYY') MENSCALUSLINPP,
                   PL.DTCALUSLINPP AS DTCALUSLINPPAUX
                FROM
                   PROPOSTALINP PL,
                   PROPOSTAFAS PR
                WHERE
                   (PL.NRPROPOSFAS  = :P_NRPROPOSFAS   ) AND
                   (PL.NRVERPROPFAS = :P_NRVERPROPFAS) AND
                   (PL.NRPROPOSFAS = PR.NRPROPOSFAS) AND
                   (PL.NRVERPROPFAS = PR.NRVERPROPFAS)
                ORDER BY
                   TO_NUMBER(PL.CDLINPPROPINFOR),
                   PL.CDLINPPROPINFOR";

        $params = array(
            ":P_NRPROPOSFAS"   => $proposta,
            ":P_NRVERPROPFAS"   => $versao,
        );

        $result = $this->_em->getConnection()->fetchAll($sql, $params);

        return $result;
    }
    
    public static function consultaProxCodigoLinhaProduto()
    {
        $sql = "
            SELECT TRIM(TO_CHAR(NVL(MAX(TO_NUMBER(PS.CDLINPPROP)), 0)+1, '00000000000000000009')) AS CDLINPPROP
              FROM PROPOSTALINP PS";        
        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public static function consultaValorIndiceLinhaProduto($nrorg, $nrProposta, $nrVersao)
    {
        $sql = "SELECT I.SGINDICE AS SGINDICE, I.NMINDICE, M.VRINDICE, TO_CHAR(M.DTREFIND,'MM/YYYY') AS DATA
                  FROM MOVINDICE M, PAR_GERAL_FAS P, INDICE I
                 WHERE M.CDTPINDICE = P.CDTPINDICE
                   AND M.IDPERVALOR = P.IDPERVALOR
                   AND M.CDINDICE   = P.CDINDICE
                   AND I.CDTPINDICE = P.CDTPINDICE
                   AND I.IDPERVALOR = P.IDPERVALOR
                   AND I.CDINDICE   = P.CDINDICE
                   AND M.DTREFIND   = (SELECT MAX(DTREFIND)
                                         FROM MOVINDICE
                                        WHERE CDTPINDICE = P.CDTPINDICE
                                          AND IDPERVALOR = P.IDPERVALOR
                                          AND CDINDICE = P.CDINDICE
                                          AND DTREFIND <= LAST_DAY(TRUNC(SYSDATE)))";
        
        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public static function consultaProxCodigoInforLinhaProduto($nrProposta, $nrVersao)
    {
        $sql = "SELECT TRIM(TO_CHAR(NVL(MAX(TO_NUMBER(PS.CDLINPPROPINFOR)), 0)+1, '09')) AS CDLINPPROPINFOR
                  FROM PROPOSTALINP PS
                 WHERE NRPROPOSFAS  = :NRPROPOSFAS
                   AND NRVERPROPFAS = :NRVERPROPFAS";
        
        $params = array('NRPROPOSFAS'  => $nrProposta,
                        'NRVERPROPFAS' => $nrVersao);
        
        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public static function consultaPrimeiraMens($nrProposta, $nrVersao)
    {
        $sql = "SELECT TO_CHAR(ADD_MONTHS(DTCALUSLINPP, 1), 'MM/YYYY') DTMESFATMENSAL,
                       TO_CHAR(ADD_MONTHS(DTCALUSLINPP, 2), 'MM/YYYY') DTMESPAGMENSAL
                  FROM PROPOSTALINP
                 WHERE NRPROPOSFAS  = :P_NRPROPOSFAS
                   AND NRVERPROPFAS = :P_NRVERPROPFAS";
        
        $params = array('P_NRPROPOSFAS'  => $nrProposta,
                        'P_NRVERPROPFAS' => $nrVersao);
        
        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
}