<?php

require_once 'base/GepTextosoliEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 * @author  Setforms
 *
 */
class GepTextosoliEntity extends GepTextosoliEntityBase
{


    const SEM_REGISTRO = 10;
    const IDATIVO = 'S';


    /**   ok
     * Gera novo codigo do texto a ser inserido para a solicitacao.
     *
     * @param integer $nrorg Nao da Organizacao.
     *
     * @return Ambigous <number, number>
     */
    public static function novoCodigoGepTextosoliLogic($nrorg){
        $codigo = Novocodigo::geraCodigo($nrorg, 'GEP_TEXTOSOLI', 10);
        return $codigo;
    }


    /**        ok
     * Retorna lista com os textos para uma determinada solicitacao.
     *
     * @param integer $nrorg Numero da Organizacao.
     * @param integer $soli  Codigo da solicitacao.
     *
     * @return Ambigous <boolean, NULL, TkModelEntity>|boolean
     */
    public function retornaDadosTextoSoli($nrorg, $soli){
        $dados = GepTextosoli::consultaTextoSoli($nrorg, $soli);

        if (is_array($dados) === true) {
            return $dados;
        }

        throw new Exception('GepTextosoli: Nao ha textos lancados para esta solicitacao', self::SEM_REGISTRO);
    }


    /**       ok
     * Insere um texto de uma determinada solicitacao.
     *
     * @param integer $codigo        Codigo do registro.
     * @param integer $soli          Numero da Solicitacao.
     * @param integer $ordem         Ordem de exibicao (opcional).
     * @param string  $grupo         Grupo a qual texto pertence (opcional).
     * @param string  $titulo        Titulo.
     * @param string  $texto         Texto.
     * @param string  $observ        Texto de Observacao do texto.
     * @param integer $nrorg         Nao da Organizacao.
     * @param date    $data          Data de insercao.
     * @param integer $operador      Operador de insercao.
     * @param string  $exclui_texto  Id para excluir o texto.
     * @param string  $alt_ordenacao Id para alterar ordenacao.
     * @param string  $alt_grupo     Id para alterar grupo.
     * @param string  $alt_titulo    Id para alterar titulo.
     *
     * @return boolean
     */
    public function insereTextosSoli(
        $codigo, $soli, $ordem, $grupo, $titulo, $texto, $observ, $nrorg, $data,
        $operador, $exclui_texto, $alt_ordenacao, $alt_grupo, $alt_titulo
    ){
        $obj = new self();

        $obj->setNrtextosoli($codigo);
        $obj->setNrsolicitacao($soli);
        $obj->setNrordenatextosoli($ordem);
        $obj->setDsgrupotextosoli($grupo);
        $obj->setDstitulotextosoli($titulo);
        $obj->setTxsolicitacao($texto);
        $obj->setDsobservtextosoli($observ);
        $obj->setIdexcluitextosoli($exclui_texto);
        $obj->setIdalteraordenatexto($alt_ordenacao);
        $obj->setIdalteragrupotexto($alt_grupo);
        $obj->setIdalteratitulotexto($alt_titulo);
        $obj->setIdativo(self::IDATIVO);
        $obj->setNrorg($nrorg);
        $obj->setDtinclusao($data);
        $obj->setDtultatu($data);
        $obj->setNrorginclusao($nrorg);
        $obj->setNrorgultatu($nrorg);
        $obj->setCdoperinclusao($operador);
        $obj->setCdoperultatu($operador);

        $obj->persist();

        return true;
    }


    /**
     * Retorna os c?os dos textos parametrizados na GEP_TEXTOSOLIFLUXO que faltam na solicita?.
     *
     * @param integer $nrorg    N?o da Organiza?.
     * @param integer $tp_fluxo Tipo de fluxo.
     * @param integer $soli     N?o da Solicita?.
     *
     * @return Ambigous <boolean, multitype:>|boolean
     */
    public function retornaTextosFaltantesSoli($nrorg, $tp_fluxo, $soli){
        $id_textos = GepTextosoli::retornaTextosFaltantesSoli($nrorg, $tp_fluxo, $soli);

        if (count($id_textos) > 0) {
            return $id_textos;
        } else {
            return false;
        }
    }


    /**   ok
     * Retorna o maior valor de ordenacao entre os textos da solicitacao.
     *
     * @param integer $nrorg Numero da Organizacao.
     * @param integer $soli  Numero da solicitacao.
     *
     * @return Ambigous <boolean, multitype:>
     */
    public static function retornaMaiorValorOrdenacaoSoli($nrorg, $soli){
        $maior = GepTextosoli::consultaMaiorValorOrdenacaoSoli($nrorg, $soli);
        return $maior;
    }


    public function retornaDadosTexto($nrorg, $cdtexto){
        $dados = GepTextosoli::consultaTexto($nrorg, $cdtexto);
        return $dados;
    }


}